clear
clc

d=[2,3,5,10,50];
rho=4;
N1=[9,19,49,99,199];
N2=N1;
R=100;


for i4=1:1:length(d)
    int1=zeros(R,length(N1));
    time1=zeros(R,length(N1));
    for i0=1:1:R
        for i1=1:1:length(N1)
            gridgamma=linspace(1/(N1(i1)+1),N1(i1)/(N1(i1)+1),N1(i1));
            gridgamma=gaminv(gridgamma,1/rho,1);
            grid=linspace(1/(N2(i1)+1),N2(i1)/(N2(i1)+1),N2(i1));

            tic
            eta1=zeros(N1(i1),N2(i1));
            for i2=1:1:N1(i1)
                eta1(i2,:)=(1-log(grid)/gridgamma(i2)).^(-1/rho);
            end

            integral1=zeros(N1(i1),1);
            for i2=1:1:N1(i1)
                integral1(i2,1)=mean(eta1(i2,:).^.5)^d(i4);
            end
            int1(i0,i1)=mean(integral1);
            time1(i0,i1)=toc;
        end
    end

    mtime=mean(time1,1);
    mint=mean(int1,1);
    sdint=std(int1,1);
    
    if i4==1
        save montecarlo2_1.mat mtime mint sdint
    elseif  i4==2
        save montecarlo2_2.mat mtime mint sdint
    elseif  i4==3
        save montecarlo2_3.mat mtime mint sdint
    elseif  i4==4
        save montecarlo2_4.mat mtime mint sdint
    elseif  i4==5
        save montecarlo2_5.mat mtime mint sdint
    end
end