clear
clc

load dataset.mat
st_dataset=sortrows(st_dataset,[2,3,8,6]);

year=double(st_dataset(:,2));% year
country=st_dataset(:,3);% country
pid=double(st_dataset(:,4));% person id
yob=double(st_dataset(:,5));% year of birth
sex=double(st_dataset(:,6));% 1 male, 2 female
educ=double(st_dataset(:,7));% 0 pre primary, 1 primary, 2 lower secondary, 3 upper secondary, 4 post secondary, 5 bachelor, 6 upper tertiary
educ(isnan(educ))=2;
hhid=double(st_dataset(:,8));% household id
basicact=double(st_dataset(:,9));% 1 work, 2 unemployed, 3 retired, 4 other inactive
basicact(isnan(basicact))=4;
child=double(st_dataset(:,10));% number of children
child_yo=double(st_dataset(:,11));% number of children under 5
rental=double(st_dataset(:,12));% income from rental of a property or land
rental(isnan(rental))=0;
inter=double(st_dataset(:,13));% interest, dividends, profit from capital, investments in unincorporated business
inter(isnan(inter))=0;

clear st_dataset

save dataeur1.mat